%bcond tests 0

%bcond cython_compile 1

%bcond emacs 0

Name:           python-cython0.29
Version:        0.29.35
Release:    1%{?dist}
Summary:        Cython 0.29.x for compatibility purposes

License:        Apache-2.0
URL:            http://www.cython.org
Source0:         https://github.com/cython/cython/archive/%{version}/Cython-%{version}.tar.gz

Patch:          emacs-docstring-wrap.patch

Patch:          https://github.com/cython/cython/commit/03c498d3142ccee2da258c540e96f12c863159fc.patch?/py3.12-tracing.patch

BuildRequires:  python3-devel
BuildRequires:  python3-setuptools

%if %{with tests}
BuildRequires:  gcc-c++
BuildRequires:  python3-numpy
BuildRequires:  python3-jedi
%endif

%if %{with cython_compile}
BuildRequires:  gcc
%global python3_site %{python3_sitearch}
%else
BuildArch:      noarch
%global python3_site %{python3_sitelib}
%endif

%global _description %{expand:
The Cython language makes writing C extensions for the Python language as easy
as Python itself. Cython is a source code translator based on Pyrex,
but supports more cutting edge functionality and optimizations.

The Cython language is a superset of the Python language (almost all Python
code is also valid Cython code), but Cython additionally supports optional
static typing to natively call C functions, operate with C++ classes and
declare fast C types on variables and class attributes.
This allows the compiler to generate very efficient C code from Cython code.

This makes Cython the ideal language for writing glue code for external C/C++
libraries, and for fast C modules that speed up the execution of Python code.

This package contains Cython 0.29.x for compatibility reasons.
Use Cython 3.0+ instead if at all possible.}

%description %{_description}


%package -n python3-cython0.29
Summary:        %{summary}
Provides:       Cython = %{version}-%{release}
Provides:       Cython = %{version}-%{release}
Provides:       cython = %{version}-%{release}
Provides:       cython = %{version}-%{release}
Conflicts:      python3-cython >= 1~~
Provides:       deprecated()

Provides:       bundled(python3dist(tempita))

%description -n python3-cython0.29 %{_description}


%if %{with emacs}
%package -n emacs-cython-mode
Summary:        A major mode for editing Cython source files in Emacs
BuildArch:      noarch
BuildRequires:  emacs
%{?_emacs_version:
Requires:       emacs(bin) >= %{_emacs_version}
}

%description -n emacs-cython-mode
cython-mode is an Emacs major mode for editing Cython source files.
%endif


%prep
%autosetup -n cython-%{version} -p1


%build
%py3_build -- %{!?with_cython_compile:--no-cython-compile}

%if %{with emacs}
echo ";;
(require 'cython-mode)" > cython-mode-init.el
cp -p Tools/cython-mode.el .
%{_emacs_bytecompile} *.el
%endif


%install
%py3_install -- %{!?with_cython_compile:--no-cython-compile}

%if %{with emacs}
mkdir -p %{buildroot}%{_emacs_sitelispdir}/
cp -p cython-mode.el cython-mode.elc %{buildroot}%{_emacs_sitelispdir}/
mkdir -p %{buildroot}%{_emacs_sitestartdir}/
cp -p cython-mode-init.el cython-mode-init.elc %{buildroot}%{_emacs_sitestartdir}/
%endif


%if %{with tests}
%check
%{python3} runtests.py -vv --no-pyregr %{?_smp_mflags} \
  %ifarch %{ix86}
  --exclude run.parallel  # https://github.com/cython/cython/issues/2807
  %endif

%endif


%files -n python3-cython0.29
%license LICENSE.txt
%doc *.txt Demos Doc Tools
%{_bindir}/cython
%{_bindir}/cygdb
%{_bindir}/cythonize
%{python3_site}/Cython-*.egg-info/
%{python3_site}/Cython/
%{python3_site}/pyximport/
%pycached %{python3_site}/cython.py

%if %{with emacs}
%files -n emacs-cython-mode
%license LICENSE.txt
%{_emacs_sitelispdir}/cython*.el*
%{_emacs_sitestartdir}/cython*.el*
%endif


%changelog
* Wed Jul 17 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.29.35-1
- initial build
